* gen_oppatients3.do

* Choose the directory where you store the files for the book.
* In the book's examples the command is -cd C:\docs\ishr2-

use oppatients1.dta

* Transform dates to years since year 0.
  gen begyear = 1960 + begdate/365.25
  gen endyear = 1960 + enddate/365.25
  gen byear = 1960 + bdate/365.25

* stset with calendar time as time axis
  stset endyear, enter(time begyear) failure(died==1) id(patid)
* Split observations, one for each calendar time band
  stsplit timeband, at(1981 1986 1991 1996 2001 2006)
* recalculate age at start and end for each timeband
  replace begage = _t0 - byear
  replace endage = _t - byear

* stset with age as time axis
  stset endage, enter(time begage) failure(died==1) id(patid)
* Split observations once more, one for each age band
  stsplit agegr, at(0 1 5(5)100)

* Before merge with the reference file, variable names must match.
  rename timeband year
  sort year sex agegr
  merge year sex agegr using dk1981-2004.dta

* Now calculate expected number of deaths
  gen pyrs = _t - _t0
  gen edied = pyrs*mrate

save oppatients3.dta
